package com.dcsoft.system.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.dcsoft.common.log.annotation.Log;
import com.dcsoft.common.log.enums.BusinessType;
import com.dcsoft.common.security.annotation.RequiresPermissions;
import com.dcsoft.system.domain.SysPeopleRecord;
import com.dcsoft.system.service.ISysPeopleRecordService;
import com.dcsoft.common.core.web.controller.BaseController;
import com.dcsoft.common.core.web.domain.AjaxResult;
import com.dcsoft.common.core.utils.poi.ExcelUtil;
import com.dcsoft.common.core.web.page.TableDataInfo;

/**
 * 人员识别记录Controller
 *
 * @author nichun
 * @date 2023-03-08
 */
@RestController
@RequestMapping("/peopleRecord")
public class SysPeopleRecordController extends BaseController
{
    @Autowired
    private ISysPeopleRecordService sysPeopleRecordService;

    /**
     * 查询人员识别记录列表
     */
    @RequiresPermissions("system:peopleRecord:list")
    @GetMapping("/list")
    public TableDataInfo list(SysPeopleRecord sysPeopleRecord)
    {
        startPage();
        List<SysPeopleRecord> list = sysPeopleRecordService.selectSysPeopleRecordList(sysPeopleRecord);
        return getDataTable(list);
    }

    /**
     * 导出人员识别记录列表
     */
    @RequiresPermissions("system:peopleRecord:export")
    @Log(title = "人员识别记录", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, SysPeopleRecord sysPeopleRecord)
    {
        List<SysPeopleRecord> list = sysPeopleRecordService.selectSysPeopleRecordList(sysPeopleRecord);
        ExcelUtil<SysPeopleRecord> util = new ExcelUtil<SysPeopleRecord>(SysPeopleRecord.class);
        util.exportExcel(response, list, "人员识别记录数据");
    }

    /**
     * 获取人员识别记录详细信息
     */
    @RequiresPermissions("system:peopleRecord:query")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return success(sysPeopleRecordService.selectSysPeopleRecordById(id));
    }

    /**
     * 新增人员识别记录
     */
    @RequiresPermissions("system:peopleRecord:add")
    @Log(title = "人员识别记录", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody SysPeopleRecord sysPeopleRecord)
    {
        return toAjax(sysPeopleRecordService.insertSysPeopleRecord(sysPeopleRecord));
    }

    /**
     * 修改人员识别记录
     */
    @RequiresPermissions("system:peopleRecord:edit")
    @Log(title = "人员识别记录", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody SysPeopleRecord sysPeopleRecord)
    {
        return toAjax(sysPeopleRecordService.updateSysPeopleRecord(sysPeopleRecord));
    }

    /**
     * 删除人员识别记录
     */
    @RequiresPermissions("system:peopleRecord:remove")
    @Log(title = "人员识别记录", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(sysPeopleRecordService.deleteSysPeopleRecordByIds(ids));
    }

    /**
     * 获取头部信息
     */
    @GetMapping("/top")
    public AjaxResult topApi() {
        return sysPeopleRecordService.topApi();
    }

    /**
     * 查询通行统计数量（昨天，今天）
     * @return
     */
    @PostMapping("/queryThroughCount")
    public AjaxResult queryThroughCount() {
        return success(sysPeopleRecordService.queryThroughCount());
    }

}
